#include <SD.h>                      // need to include the SD library
//#define SD_ChipSelectPin 53  //example uses hardware SS pin 53 on Mega2560
#define SD_ChipSelectPin 10  //using digital pin 4 on arduino nano 328
#include <TMRpcm.h>           //  also need to include this library...
#include <SoftwareSerial.h>
#include "EEPROM.h"

SoftwareSerial BTSerial(7, 8); // RX, TX

TMRpcm tmrpcm;   // create an object for use in this sketch
char mychar;
byte octet;
byte octet0=0;
int n=0;
int compteur=0;
long t0=millis();
int dt;
int son=0;
int ma=1;
long t1=millis();
int sifflet=0;
int vr;
int cr=0;
int enr=0;
int lect=0;
long t2=millis();
int dt2;
int ce=0;
int p=0;
int cl=0;
int csy=0;
int enr1=0;
float n1;
int transfert=0;
byte octet1;
byte octet2;



void setup(){

  tmrpcm.speakerPin = 9; //11 on Mega, 9 on Uno, Nano, etc
pinMode(2,OUTPUT);
pinMode(6,OUTPUT);
pinMode(5,OUTPUT);
  Serial.begin(9600);
  BTSerial.begin(9600);
  if (!SD.begin(SD_ChipSelectPin)) {  // see if the card is present and can be initialized:
    Serial.println("SD fail");  
    return;   // don't do anything more if not
  }
digitalWrite(2,LOW);
digitalWrite(6,LOW);
digitalWrite(5,LOW); 
}

void loop(){

    if(BTSerial.available()){   
    octet = BTSerial.read() ;
    Serial.println(octet);
    }
if (octet != octet0) {
if (enr1==0) {
if (octet==0)  ma=0;
if (octet==1)  ma=1;
if (octet==150) digitalWrite(2,HIGH);
if (octet==151) digitalWrite(2,LOW);
if (octet==152 && son==0 && sifflet==0) {
tmrpcm.play("01.wav");
son=1;
}
if (octet==153 && son==1) {
son=0;
}
if (octet==156 ) {
tmrpcm.play("10.wav");
}

if (octet>99 && octet<121) dt=2*(octet-100);
if (dt>20) dt=20;
if (octet==154 && son==1 ) {
sifflet=1;
tmrpcm.play("07.wav");
}

if (octet==155 && son==1 ) sifflet=0;
if (octet==156 && son==1 ) {
sifflet=1;
tmrpcm.play("08.wav");
}
if (octet==157 && son==1 ) sifflet=0;
// commande son
if (son==1 && dt>0 && dt<=3 && sifflet==0) {
tmrpcm.play("02.wav");  
}
if (son==1 && dt>3 && dt<=5 && sifflet==0) {
tmrpcm.play("03.wav");  
}
if (son==1 && dt>5 && dt<=8 && sifflet==0) {
tmrpcm.play("04.wav");  
}
if (son==1 && dt>8 && dt<=20 && sifflet==0) {
tmrpcm.play("05.wav");  
}


if (octet0>100 && octet==100 && son==1 ) tmrpcm.play("06.wav");  
}

// enregistrement du trajet dans l'EEPROM
if (enr==1 && lect==0) {
  n=n+1;
  EEPROM.write(n, octet);
  dt2=(int)((millis()-t2)/1000);
  if (dt2==0) dt2=1;
  EEPROM.write(n+500, dt2);
  t2=millis();
 if (octet==123) enr=0; 
}
if (octet==122) enr=1;

// transfert des octets de la tablette vers l'EEPROM
if (enr1==1) {
 n=n+1;
 n1=(float)n/2.0;

if (n1-int(n1)>0) {
EEPROM.write(int(n1)+1, octet); 

}
if (n1-int(n1)==0) {
EEPROM.write(int(n1)+500, octet);

}
 if (octet==123) {
  enr1=0;
  n=0; 
 }
}
if (octet==219) {
  enr1=1;
  n=0;            
}
if (octet==220) enr1=0;

if (octet==217) {
  transfert=1;
  n=0;
}

octet0=octet;
} 



// commande moteur

if (ma==1) {
digitalWrite(5,LOW); 
if (millis()<t0+dt) digitalWrite(6,HIGH); 
if (millis()>t0+dt && millis()<t0+20) digitalWrite(6,LOW);  
if (millis()>t0+20) t0=millis();  
}

if (ma==0) {
digitalWrite(6,LOW); 
if (millis()<t0+dt) digitalWrite(5,HIGH); 
if (millis()>t0+dt && millis()<t0+20) digitalWrite(5,LOW);  
if (millis()>t0+20) t0=millis();  
} 
 
// rétrosignalisation

vr= analogRead(A0);


if (vr<100 && cr==0) {
  BTSerial.write(215);
    // enregistrement retro
if (enr==1 && lect==0) {
  n=n+1;
  EEPROM.write(n, 200);
  dt2=(int)((millis()-t2)/1000);
  if (dt2==0) dt2=1;
 
  EEPROM.write(n+500, 2);
  t2=millis();
}
  cr=1;
  t1=millis();
  
 
}
 
if (cr==1 && millis()>t1+4000) {
  cr=0;
  BTSerial.write(216);
}

// exécution automatique du trajet
if (octet==124 && ce==0) {
lect=1;
n=0;
ce=1;
cl=0;
}

if (octet==125 && ce==1) {
lect=0;
n=0;
ce=0;
cl=0;
p=1;
}

 if (lect==1) {
 
  if (cl==0) {
  octet = EEPROM.read(p);
  dt2 = EEPROM.read(p+501);
 BTSerial.write(octet);
 if (octet==205) csy=1;
  
  cl=1;
  t2=millis();
  }
  if (octet==123) {
  p=1;
  cl=0;
  }
 if (octet<200 && cl==1 && millis()>t2+dt2*1000) {
  p=p+1;
  cl=0;
 }
  if (octet>200 && octet<205 && cl==1 && millis()>t2+dt2*1000) {
  p=p+1;
  cl=0;
 }
  if (octet==200 && cl==1 && cr==1) {
  cl=2;
  t2=millis();
 }
  if (octet==200 && cl==2 && millis()>t2+dt2*1000) {
  p=p+1;
  cl=0;
 }
 if (csy==1 && cl==1 && octet==210) {
  p=p+1;
  cl=0;
  csy=0;
 }
 
 }

// transfert des octets de l'EEPROM vers la tablette
if (transfert==1) {
n=n+1;
octet1 = EEPROM.read(n);  
BTSerial.write(octet1);
if (octet1==123) {
transfert=0;
n=0;
}
delay(1000);
octet2 = EEPROM.read(n+500);
BTSerial.write(octet2); 
delay(1000);

}




}


